
#ifndef GSETGEN_H
#define GSETGEN_H

#define XMLKEY_GEN   "gen"
#define DEF_GNSSSYST "GPS GLO GAL BDS SBAS"
#define DEF_SATELLIT_G "G01 G02 G03 G04 G05 G06 G07 G08 G09 G10 G11 G12 G13 G14 G15 G16 G17 G18 G19 G20 G21 G22 G23 G24 G25 G26 G27 G28 G29 G30 G31 G32 "
#define DEF_SATELLIT_R "R01 R02 R03 R04 R05 R06 R07 R08 R09 R10 R11 R12 R13 R14 R15 R16 R17 R18 R19 R20 R21 R22 R23 R24 "
#define DEF_SATELLIT_E "E11 E12 E19 E20 "
#define DEF_SATELLIT_J "J01 "
#define DEF_SATELLIT_C "C01 C02 C03 C04 C05 C06 C07 C08 C09 C10 C11 C12 C13 C14 "
#define DEF_SATELLIT_S "S20 S36 S24 S26 S27 S28 S29 S37 S83 S40 S25 S35 S38 S33 "
#define DEF_SATELLIT DEF_SATELLIT_G DEF_SATELLIT_R DEF_SATELLIT_E DEF_SATELLIT_J DEF_SATELLIT_C DEF_SATELLIT_S
#define DEF_RECEIVER ""    // all !
#define DEF_OBSERVAT ""    // all !
#define DEF_SAMPLING "30"  // 30s !

/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: implements common general settings
  Version: $ Rev: $

  2012-10-23 /JD: created

-*/

#include <set>
#include <string>
#include <iostream>

#ifdef BMUTEX
  #include <boost/thread/mutex.hpp>
#endif

#include "gio/glog.h"
#include "gutils/gtime.h"
#include "gutils/gtypeconv.h"
#include "gsetbase.h"

using namespace std;

class t_gsetgen : public virtual t_gsetbase
{
 public:
   t_gsetgen();
  ~t_gsetgen();

   void check();                                  // settings check
   void help();                                   // settings help
   
   t_gtime beg();
   t_gtime end();
   int sampling();

   set<string> sys();
   set<string> rec();
   set<string> sat();
   set<string> obs();

 protected:
   
 private:
};

#endif
