
#ifndef GCOMMON_H
#define GCOMMON_H 
 
/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: 
  Version: $ Rev: $

  2011-02-14 /JD: created

-*/

#include <string>
#include <iomanip>
#include <sstream>

using namespace std;

inline void gtrace(const string& str)
{
#ifdef TRACE
  cout << "#" << str << endl;
#endif
};

inline void gclk(const string& str, time_t& clk)  // usage:  clock_t clk; gclk("TEXT",clk);
{
#ifdef CLOCK
  cout << "#"
       << fixed << setprecision(4)
       << setw(7) << difftime(time(0) - clk) << " sec: "
       << str << " " << endl;
  clk = time(0); // clock();
#endif
};

// this is designed for main program
inline string clk_string( clock_t clk )
{
  clk = clock() - clk;
  ostringstream os;
  os << fixed << setprecision(3) << setw(7) << ((float)clk)/CLOCKS_PER_SEC << " sec ";
  return os.str();
}

/*
inline void gclk(const string& str, clock_t& clk)  // usage:  clock_t clk; gclk("TEXT",clk);
{
#ifdef CLOCK
  cout << "#"
       << fixed << setprecision(4)
       << setw(7) << (double)( clock()-clk )/CLOCKS_PER_SEC << " sec: "
       << str << " " << endl;
  clk = clock();
#endif
};
*/

#ifdef DEBUG
 #define ID_FUNC printf(" .. %s\n", __func__)
#else
 #define ID_FUNC 
#endif

#define SQR(x)   ((x)*(x))
#define SQRT(x)  ((x)<=0.0?0.0:sqrt(x))

#endif // # GCOMMON_H



