
#ifndef GSYSCONV_H
#define GSYSCONV_H
 
/* ----------------------------------------------------------------------
  (c) 2011 Geodetic Observatory Pecny, http://www.pecny.cz (gnss@pecny.cz)
      Research Institute of Geodesy, Topography and Cartography
      Ondrejov 244, 251 65, Czech Republic

  Purpose: reference system conversion utilities
  Version: $ Rev: $

  2011-04-26 /PV: created
  2012-04-06 /JD: extracted coordinate system conversion utilities only

-*/

#include <string>
#include <gutils/gtriple.h>

#include "../newmat/newmat.h"
#include "../newmat/newmatio.h"

using namespace std;

int xyz2ell(const double* XYZ, double* Ell, bool degrees = false);
int xyz2neu(const double* XYZ, const double* XYZ_Ref, double* neu);
int neu2xyz(const double* Ell, const double* neu,     double* xyz);
int rao2xyz(const ColumnVector& pos, const ColumnVector& vel,
            const ColumnVector& rao, ColumnVector& xyz);

int  xyz2ell(t_gtriple &crd, t_gtriple &ell, bool degrees = false);
void xyz2neu(t_gtriple &crd, t_gtriple &crd_site, t_gtriple &neu);
void neu2xyz(t_gtriple &ell, t_gtriple &neu, t_gtriple &crd);

#endif // GSYSCONV_H
